#include <iostream>
#include <algorithm>
#include <math.h>

using namespace std;

bool check(long long a) {
    long long i = 2;
    for (i = 2; i < sqrt(a); i++){
        if (a%i==0){
            return false;
        }
    }
    return true;
}

long long nok(long long a, long long b) {
    long long r1;
    long long r2, r = 1;
    long long i;
    if (a < b) {
        swap(a, b);
    }
    for (i = 2; i <= a; i++) {
        r1 = 0;
        r2 = 0;
        while (a % i == 0) {
            a /= i;
            r1++;
        }
        while (b % i == 0) {
            b /= i;
            r2++;
        }
        r1 = max(r2, r1);
        while (r1 > 0) {
            r *= i;
            r1--;
        }
    }
    return r;
}

long long nod(long long a, long long b) {
    if (a < b) {
        swap(a, b);
    }
    if (check(a) && check(b)) return 1;
    while (b != 1) {
        while (a / b > 0) {
            a /= b;
        }
        swap(a, b);
    }
    return a;
}

int main() {
    long long n, a, b, x, y, i;
    cin >> n;
    cin >> x >> y;
    for (i = 0; i < n - 1; i++) {
        cin >> a >> b;
        y = nod(y, b);
        x = nok(x, a);
    }
    cout << x << " " << y;
    return 0;
}
